## GtkBox GtkBox — A container box |

## Functions

GtkWidget * | gtk_box_new ()
void | gtk_box_pack_start ()
void | gtk_box_pack_end ()
gboolean | gtk_box_get_homogeneous ()
void | gtk_box_set_homogeneous ()
gint | gtk_box_get_spacing ()
void | gtk_box_set_spacing ()
void | gtk_box_reorder_child ()
void | gtk_box_query_child_packing ()
void | gtk_box_set_child_packing ()
GtkBaselinePosition | gtk_box_get_baseline_position ()
void | gtk_box_set_baseline_position ()
GtkWidget * | gtk_box_get_center_widget ()
void | gtk_box_set_center_widget ()

## Properties

GtkBaselinePosition | baseline-position | Read / Write
gboolean | homogeneous | Read / Write
gint | spacing | Read / Write

## Child Properties

gboolean | expand | Read / Write
gboolean | fill | Read / Write
GtkPackType | pack-type | Read / Write
guint | padding | Read / Write
gint | position | Read / Write

## Types and Values

struct | GtkBox
struct | GtkBoxClass

## Object Hierarchy

        GObject
        ╰── GInitiallyUnowned
            ╰── GtkWidget
                ╰── GtkContainer
                    ╰── GtkBox
                        ├── GtkAppChooserWidget
                        ├── GtkButtonBox
                        ├── GtkColorChooserWidget
                        ├── GtkColorSelection
                        ├── GtkFileChooserButton
                        ├── GtkFileChooserWidget
                        ├── GtkFontChooserWidget
                        ├── GtkFontSelection
                        ├── GtkHBox
                        ├── GtkInfoBar
                        ├── GtkRecentChooserWidget
                        ├── GtkShortcutsSection
                        ├── GtkShortcutsGroup
                        ├── GtkShortcutsShortcut
                        ├── GtkStackSwitcher
                        ├── GtkStatusbar
                        ╰── GtkVBox

## Implemented Interfaces

GtkBox implements AtkImplementorIface, GtkBuildable and GtkOrientable.

## Includes

    #include <gtk/gtk.h>

## Description

The GtkBox widget organizes child widgets into a rectangular area.

The rectangular area of a GtkBox is organized into either a single row or a single column of child widgets depending upon the orientation. Thus, all children of a GtkBox are allocated one dimension in common, which is the height of a row, or the width of a column.

GtkBox uses a notion of packing. Packing refers to adding widgets with reference to a particular position in a GtkContainer. For a GtkBox, there are two reference positions: the start and the end of the box. For a vertical GtkBox, the start is defined as the top of the box and the end is defined as the bottom. For a horizontal GtkBox the start is defined as the left side and the end is defined as the right side.

Use repeated calls to `gtk_box_pack_start()` to pack widgets into a GtkBox from start to end. Use `gtk_box_pack_end()` to add widgets from end to start. You may intersperse these calls and add widgets from both ends of the same GtkBox.

Because GtkBox is a GtkContainer, you may also use `gtk_container_add()` to insert widgets into the box, and they will be packed with the default values for expand and fill child properties. Use `gtk_container_remove()` to remove widgets from the GtkBox.

Use `gtk_box_set_homogeneous()` to specify whether or not all children of the GtkBox are forced to get the same amount of space.

Use `gtk_box_set_spacing()` to determine how much space will be minimally placed between all children in the GtkBox. Note that spacing is added between the children, while padding added by `gtk_box_pack_start()` or `gtk_box_pack_end()` is added on either side of the widget it belongs to.

Use `gtk_box_reorder_child()` to move a GtkBox child to a different place in the box.

Use `gtk_box_set_child_packing()` to reset the expand, fill and padding child properties. Use `gtk_box_query_child_packing()` to query these fields.

Note that a single-row or single-column GtkGrid provides exactly the same functionality as GtkBox.

### CSS nodes

GtkBox uses a single CSS node with name box.

In horizontal orientation, the nodes of the children are always arranged from left to right. So :first-child will always select the leftmost child, regardless of text direction.

## Functions

### gtk_box_new ()

    GtkWidget *
    gtk_box_new (GtkOrientation orientation,
                 gint spacing);

Creates a new GtkBox.

#### Parameters

orientation | the box’s orientation. |
spacing | the number of pixels to place by default between children. |

#### Returns

a new GtkBox.

Since: 3.0

### gtk_box_pack_start ()

    void
    gtk_box_pack_start (GtkBox *box,
                        GtkWidget *child,
                        gboolean expand,
                        gboolean fill,
                        guint padding);

Adds `child` to `box` , packed with reference to the start of `box` . The `child` is packed after any other child packed with reference to the start of `box` .

#### Parameters

box | a GtkBox |
child | the GtkWidget to be added to `box` |
expand | `TRUE` if the new child is to be given extra space allocated to `box` . The extra space will be divided evenly between all children that use this option |
fill | `TRUE` if space given to `child` by the `expand` option is actually allocated to `child` , rather than just padding it. This parameter has no effect if `expand` is set to `FALSE`. A child is always allocated the full height of a horizontal GtkBox and the full width of a vertical GtkBox. This option affects the other dimension |
padding | extra space in pixels to put between this child and its neighbors, over and above the global amount specified by “spacing” property. If `child` is a widget at one of the reference ends of `box` , then `padding` pixels are also put between `child` and the reference edge of `box` |

### gtk_box_pack_end ()

    void
    gtk_box_pack_end (GtkBox *box,
                      GtkWidget *child,
                      gboolean expand,
                      gboolean fill,
                      guint padding);

Adds `child` to `box` , packed with reference to the end of `box` . The `child` is packed after (away from end of) any other child packed with reference to the end of `box` .

#### Parameters

box | a GtkBox |
child | the GtkWidget to be added to `box` |
expand | `TRUE` if the new child is to be given extra space allocated to `box` . The extra space will be divided evenly between all children of `box` that use this option |
fill | `TRUE` if space given to `child` by the `expand` option is actually allocated to `child` , rather than just padding it. This parameter has no effect if `expand` is set to `FALSE`. A child is always allocated the full height of a horizontal GtkBox and the full width of a vertical GtkBox. This option affects the other dimension |
padding | extra space in pixels to put between this child and its neighbors, over and above the global amount specified by “spacing” property. If `child` is a widget at one of the reference ends of `box` , then `padding` pixels are also put between `child` and the reference edge of `box` |

### gtk_box_get_homogeneous ()

    gboolean
    gtk_box_get_homogeneous (GtkBox *box);

Returns whether the box is homogeneous (all children are the same size). See `gtk_box_set_homogeneous()`.

#### Parameters

box | a GtkBox |

#### Returns

`TRUE` if the box is homogeneous.

### gtk_box_set_homogeneous ()

    void
    gtk_box_set_homogeneous (GtkBox *box,
                             gboolean homogeneous);

Sets the “homogeneous” property of `box` , controlling whether or not all children of `box` are given equal space in the box.

#### Parameters

box | a GtkBox |
homogeneous | a boolean value, `TRUE` to create equal allotments, `FALSE` for variable allotments |

### gtk_box_get_spacing ()

    gint
    gtk_box_get_spacing (GtkBox *box);

Gets the value set by `gtk_box_set_spacing()`.

#### Parameters

box | a GtkBox |

#### Returns

spacing between children

### gtk_box_set_spacing ()

    void
    gtk_box_set_spacing (GtkBox *box,
                         gint spacing);

Sets the “spacing” property of `box` , which is the number of pixels to place between children of `box` .

#### Parameters

box | a GtkBox |
spacing | the number of pixels to put between children |

### gtk_box_reorder_child ()

    void
    gtk_box_reorder_child (GtkBox *box,
                           GtkWidget *child,
                           gint position);

Moves `child` to a new `position` in the list of `box` children. The list contains widgets packed GTK_PACK_START as well as widgets packed GTK_PACK_END, in the order that these widgets were added to `box` .

A widget’s position in the `box` children list determines where the widget is packed into `box` . A child widget at some position in the list will be packed just after all other widgets of the same packing type that appear earlier in the list.

#### Parameters

box | a GtkBox |
child | the GtkWidget to move |
position | the new position for `child` in the list of children of `box` , starting from 0. If negative, indicates the end of the list |

### gtk_box_query_child_packing ()

    void
    gtk_box_query_child_packing (GtkBox *box,
                                 GtkWidget *child,
                                 gboolean *expand,
                                 gboolean *fill,
                                 guint *padding,
                                 GtkPackType *pack_type);

Obtains information about how `child` is packed into `box` .

#### Parameters

box | a GtkBox |
child | the GtkWidget of the child to query |
expand | pointer to return location for expand child property. | [out]
fill | pointer to return location for fill child property. | [out]
padding | pointer to return location for padding child property. | [out]
pack_type | pointer to return location for pack-type child property. | [out]

### gtk_box_set_child_packing ()

    void
    gtk_box_set_child_packing (GtkBox *box,
                               GtkWidget *child,
                               gboolean expand,
                               gboolean fill,
                               guint padding,
                               GtkPackType pack_type);

Sets the way `child` is packed into `box` .

#### Parameters

box | a GtkBox |
child | the GtkWidget of the child to set |
expand | the new value of the expand child property |
fill | the new value of the fill child property |
padding | the new value of the padding child property |
pack_type | the new value of the pack-type child property |

### gtk_box_get_baseline_position ()

    GtkBaselinePosition
    gtk_box_get_baseline_position (GtkBox *box);

Gets the value set by `gtk_box_set_baseline_position()`.

#### Parameters

box | a GtkBox |

#### Returns

the baseline position

Since: 3.10

### gtk_box_set_baseline_position ()

    void
    gtk_box_set_baseline_position (GtkBox *box,
                                   GtkBaselinePosition position);

Sets the baseline position of a box. This affects only horizontal boxes with at least one baseline aligned child. If there is more vertical space available than requested, and the baseline is not allocated by the parent then `position` is used to allocate the baseline wrt the extra space available.

#### Parameters

box | a GtkBox |
position | a GtkBaselinePosition |

Since: 3.10

### gtk_box_get_center_widget ()

    GtkWidget *
    gtk_box_get_center_widget (GtkBox *box);

Retrieves the center widget of the box.

#### Parameters

box | a GtkBox |

#### Returns

the center widget or `NULL` in case no center widget is set.

[transfer none][nullable]

Since: 3.12

### gtk_box_set_center_widget ()

    void
    gtk_box_set_center_widget (GtkBox *box,
                               GtkWidget *widget);

Sets a center widget; that is a child widget that will be centered with respect to the full width of the box, even if the children at either side take up different amounts of space.

#### Parameters

box | a GtkBox |
widget | the widget to center. | [allow-none]

Since: 3.12

## Types and Values

### struct GtkBox

    struct GtkBox;

### struct GtkBoxClass

    struct GtkBoxClass {
      GtkContainerClass parent_class;
    };

#### Members

## Property Details

### The `“baseline-position”` property

      “baseline-position”        GtkBaselinePosition

The position of the baseline aligned widgets if extra space is available.

Flags: Read / Write

Default value: GTK_BASELINE_POSITION_CENTER

### The `“homogeneous”` property

      “homogeneous”              gboolean

Whether the children should all be the same size.

Flags: Read / Write

Default value: FALSE

### The `“spacing”` property

      “spacing”                  gint

The amount of space between children.

Flags: Read / Write

Allowed values: >= 0

Default value: 0

## Child Property Details

### The `“expand”` child property

      “expand”                   gboolean

Whether the child should receive extra space when the parent grows.

Note that the default value for this property is `FALSE` for GtkBox, but GtkHBox, GtkVBox and other subclasses use the old default of `TRUE`.

Note that the “halign”, “valign”, “hexpand” and “vexpand” properties are the preferred way to influence child size allocation in containers.

In contrast to “hexpand”, the expand child property does not cause the box to expand itself.

Flags: Read / Write

Default value: FALSE

### The `“fill”` child property

      “fill”                     gboolean

Whether the child should receive extra space when the parent grows.

Note that the “halign”, “valign”, “hexpand” and “vexpand” properties are the preferred way to influence child size allocation in containers.

Flags: Read / Write

Default value: TRUE

### The `“pack-type”` child property

      “pack-type”                GtkPackType

A GtkPackType indicating whether the child is packed with reference to the start or end of the parent.

Flags: Read / Write

Default value: GTK_PACK_START

### The `“padding”` child property

      “padding”                  guint

Extra space to put between the child and its neighbors, in pixels.

Flags: Read / Write

Allowed values: <= G_MAXINT

Default value: 0

### The `“position”` child property

      “position”                 gint

The index of the child in the parent.

Flags: Read / Write

Allowed values: >= -1

Default value: 0

## See Also

GtkFrame, GtkGrid, GtkLayout